#include "m_pd.h"
#include "counter.h"

static t_class *counter_class;

typedef struct _counter {
  t_object  x_obj;
  Counter *cnt;
} t_counter;

void counter_bang(t_counter *x) {
  t_float f;
  f = x->cnt->Incr();
  outlet_float(x->x_obj.ob_outlet, f);
}

void *counter_new(t_floatarg f) {

  t_counter *x = (t_counter *)pd_new(counter_class);
  
  outlet_new(&x->x_obj, &s_float);

  x->cnt = new Counter(f);
  
  return (void *)x;
}

void counter_setup(void) {
  counter_class = class_new(gensym("counter"),
			    (t_newmethod)counter_new,
			    0, sizeof(t_counter),
			    CLASS_DEFAULT,
			    A_DEFFLOAT, 0);

  class_addbang(counter_class, counter_bang);
}

